SystemOrganization addCategory: #'OCMS-Database'!

Object subclass: #OCMSDB
	instanceVariableNames: 'session'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OCMS-Database'!

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 6/2/2013 17:58'!
commit: anDBOperation
	self default session commit: anDBOperation.
	self session refresh.! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:15'!
default
	^ Default ifNil: [Default := self new connect; yourself].! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 20:33'!
release
	Default ifNil: [
		Default session disconnectAndClose.
		Default := nil.
		]! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:22'!
root
	^ self session root! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:20'!
session
	^ self default session! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 6/24/2013 15:07'!
updateDBObjects
	"I initialize MagmaCollection at the keys of OCMSDB if they do not exist"
	
	self commit:[
					(OCMSDB root includesKey: 'comments')
						ifFalse:[self session root at: 'comments' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'courses')
						ifFalse:[self session root at: 'courses' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'coursewares')
						ifFalse:[self session root at: 'coursewares' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'notifications')
						ifFalse:[self session root at: 'notifications' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'users')
						ifFalse:[self session root at: 'users' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'tags')
						ifFalse:[self session root at: 'tags' put: MagmaCollection new.].
				]! !

!OCMSDB class methodsFor: 'as yet unclassified' stamp: 'has 6/24/2013 15:28'!
updateIndexes
	"I initialize indexes of DBObjects in OCMSDB if they do not exist"
	
	self commit:[
					((self session root at: 'comments') hasIndexNamed: #id)
						ifFalse:[(self session root at: 'comments') addIndex: (MaIntegerIndex attribute: #id)].
					((self session root at: 'comments') hasIndexNamed: #login)
						ifFalse:[(self session root at: 'comments') addIndex: (MaSearchStringIndex attribute: #login)].

					((self session root at: 'courses') hasIndexNamed: #name)
						ifFalse:[(self session root at: 'courses') addIndex: (MaSearchStringIndex attribute: #name)].

					((self session root at: 'coursewares') hasIndexNamed: #id)
						ifFalse:[(self session root at: 'coursewares') addIndex: (MaIntegerIndex attribute: #id)].
					((self session root at: 'coursewares') hasIndexNamed: #title)
						ifFalse:[(self session root at: 'coursewares') addIndex: (MaSearchStringIndex attribute: #title)].

					((self session root at: 'notifications') hasIndexNamed: #id)
						ifFalse:[(self session root at: 'notifications') addIndex: (MaIntegerIndex attribute: #id)].

					((self session root at: 'tags') hasIndexNamed: #name)
						ifFalse:[(self session root at: 'tags') addIndex: (MaSearchStringIndex attribute: #name)].

					((self session root at: 'users') hasIndexNamed: #login)
						ifFalse:[(self session root at: 'users') addIndex: (MaSearchStringIndex attribute: #login)].
					((self session root at: 'users') hasIndexNamed: #name)
						ifFalse:[(self session root at: 'users') addIndex: (MaSearchStringIndex attribute: #name)].
					((self session root at: 'users') hasIndexNamed: #email)
						ifFalse:[(self session root at: 'users') addIndex: (MaSearchStringIndex attribute: #email)].
				]! !

!OCMSDB methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:18'!
connect
	session := (MagmaRemoteLocation
				host: 'localhost'
				port: 51001) newSession.
	session connectAs: 'higor'.! !

!OCMSDB methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:19'!
session
	^ session! !

Object subclass: #OCMSTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

OCMSTable subclass: #Comments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Comments class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:00'!
add: aComment
	aComment createId.
	OCMSDB commit: [self database add: aComment].! !

!Comments class methodsFor: 'creation' stamp: 'has 6/22/2013 23:12'!
database
	^ OCMSDB root at: 'comments'.! !

!Comments class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:20'!
getAll
	"I return a collection with all comments in database"
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!Comments class methodsFor: 'ma operation' stamp: 'has 6/23/2013 00:36'!
remove: aComment
	(self database includes: aComment)
		ifTrue:[OCMSDB commit: [self database remove: aComment]]
		ifFalse:[self error: 'This comment does not exist'].! !

!Comments class methodsFor: 'ma searching' stamp: 'has 6/23/2013 08:12'!
searchById: aHash
	"return a comment with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = aHash].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Comments class methodsFor: 'ma searching' stamp: 'has 6/24/2013 15:29'!
searchByUserLogin: anUserLogin
	"I return a collection with comments from the typed login"
	| reader |
	reader := self database where: [:each | each login from: anUserLogin to: anUserLogin maAlphabeticalNext].
	^ reader.! !

!Comments class methodsFor: 'ma operation' stamp: 'has 6/23/2013 00:43'!
update: aComment
	(self database includes: aComment)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aComment.
					self database add: aComment].
				]
		ifFalse:[self error: 'This comment does not exist'].! !

OCMSTable subclass: #Courses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Courses class methodsFor: 'ma operation' stamp: 'has 6/23/2013 09:25'!
add: aCourse
	"aComment createId."
	OCMSDB commit: [self database add: aCourse].! !

!Courses class methodsFor: 'creation' stamp: 'has 6/23/2013 09:24'!
database
	^ OCMSDB root at: 'courses'.! !

!Courses class methodsFor: 'ma searching' stamp: 'has 6/24/2013 14:37'!
getAll
	"I return a collection with all courses in database"
	| reader |
	reader := self database where: [:each | each name from: '' maAlphabeticalNext].
	^ reader.! !

!Courses class methodsFor: 'ma operation' stamp: 'has 6/23/2013 09:25'!
remove: aCourse
	(self database includes: aCourse)
		ifTrue:[OCMSDB commit: [self database remove: aCourse]]
		ifFalse:[self error: 'This course does not exist'].! !

!Courses class methodsFor: 'ma searching' stamp: 'has 6/24/2013 14:35'!
searchByName: aName
	"I return a collection with courses that contain the typed name"
	| reader |
	reader := self database where: [:each | each name from: aName to: aName maAlphabeticalNext].
	^ reader.! !

!Courses class methodsFor: 'ma operation' stamp: 'has 6/23/2013 09:26'!
update: aCourse
	(self database includes: aCourse)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aCourse.
					self database add: aCourse].
				]
		ifFalse:[self error: 'This course does not exist'].! !

OCMSTable subclass: #Coursewares
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Coursewares class methodsFor: 'ma operation' stamp: 'has 5/26/2013 11:59'!
add: aCourseware
	aCourseware id: self incrementId.
	OCMSDB commit: [self database add: aCourseware].! !

!Coursewares class methodsFor: 'creation' stamp: 'has 5/25/2013 20:15'!
database
	^ OCMSDB root at: 'coursewares'.! !

!Coursewares class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:27'!
getAll
	"I return a collection with all coursewares in database"
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!Coursewares class methodsFor: 'creation' stamp: 'has 6/2/2013 16:45'!
incrementId
	| maxCourseware newId |
	newId := 0.
	(self database size > 0)
		ifTrue: [	maxCourseware := self database detectMax: #id.
				newId := maxCourseware id + 1]
		ifFalse: [newId := 1].
	^ newId.! !

!Coursewares class methodsFor: 'ma operation' stamp: 'has 6/2/2013 19:31'!
remove: aCourseware
	(self database includes: aCourseware)
		ifTrue:[OCMSDB commit: [self database remove: aCourseware]]
		ifFalse:[self error: 'This courseware does not exist'].! !

!Coursewares class methodsFor: 'ma searching' stamp: 'has 6/2/2013 10:19'!
searchById: anId
	"return a courseware with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = anId].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Coursewares class methodsFor: 'ma searching' stamp: 'has 6/2/2013 19:22'!
searchByTitle: aTitle
	"I return a collection with coursewares that contain the typed title"
	| reader |
	reader := self database where: [:each | each title from: aTitle to: aTitle maAlphabeticalNext].
	^ reader.! !

!Coursewares class methodsFor: 'ma operation' stamp: 'has 6/2/2013 18:18'!
update: aCourseware
	(self database includes: aCourseware)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aCourseware.
					self database add: aCourseware].
				]
		ifFalse:[self error: 'This courseware does not exist'].! !

OCMSTable subclass: #OCMSNotifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!OCMSNotifications class methodsFor: 'ma operation' stamp: 'has 6/23/2013 15:18'!
add: aNotification
	OCMSDB commit: [self database add: aNotification].! !

!OCMSNotifications class methodsFor: 'creation' stamp: 'has 6/23/2013 07:08'!
database
	^ OCMSDB root at: 'notifications'.! !

!OCMSNotifications class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:21'!
getAll
	"I return a collection with all comments in database"
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!OCMSNotifications class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:04'!
remove: aNotification
	(self database includes: aNotification)
		ifTrue:[OCMSDB commit: [self database remove: aNotification]]
		ifFalse:[self error: 'This notification does not exist'].! !

!OCMSNotifications class methodsFor: 'ma searching' stamp: 'has 6/23/2013 08:12'!
searchById: aHash
	"return a notification with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = aHash].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!OCMSNotifications class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:08'!
update: aNotification
	(self database includes: aNotification)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aNotification.
					self database add: aNotification].
				]
		ifFalse:[self error: 'This notification does not exist'].! !

!OCMSTable class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:35'!
add: anObject
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'creation' stamp: 'has 6/23/2013 08:32'!
database
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'ma searching' stamp: 'has 6/23/2013 08:43'!
getAll
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:39'!
remove: anObject
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:40'!
update: anObject
	self subclassResponsibility! !

OCMSTable subclass: #Tags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Tags class methodsFor: 'ma operation' stamp: 'has 6/24/2013 19:22'!
add: aTag
	(self tagExists: aTag)
		ifFalse:[OCMSDB commit:[self database add: aTag]]
		ifTrue:[self error: 'This tag already exists.'].! !

!Tags class methodsFor: 'creation' stamp: 'has 6/3/2013 09:44'!
database
	^ OCMSDB root at: 'tags'.! !

!Tags class methodsFor: 'ma searching' stamp: 'has 6/24/2013 19:44'!
getAll
	"I return a collection with all tags in database"
	| reader |
	reader := self database where: [:each | each name from: '' maAlphabeticalNext].
	^ reader.! !

!Tags class methodsFor: 'ma operation' stamp: 'has 6/3/2013 10:22'!
remove: aTag
	(self tagExists: aTag)
		ifTrue:[OCMSDB commit: [self database remove: aTag]]
		ifFalse:[self error: 'This tag does not exist'].! !

!Tags class methodsFor: 'ma searching' stamp: 'has 6/24/2013 19:38'!
searchTag: aTag
	"I return a collection with tags that contain the typed tag name"
	| reader tagName |
	tagName := aTag name.
	reader := self database where: [:each | each from: tagName to: tagName maAlphabeticalNext].
	^ reader.! !

!Tags class methodsFor: 'testing' stamp: 'has 6/24/2013 19:03'!
tagExists: aTag
	"I return true if the tag already exists."
	| tagTemp |
	(self database size = 0)
		ifTrue:[^false].
		
	tagTemp := self searchTag: aTag.
	(tagTemp isNil)
		ifTrue:[^ false]
		ifFalse:[^ true].! !

!Tags class methodsFor: 'ma operation' stamp: 'has 6/3/2013 10:22'!
update: aTag
	(self tagExists: aTag)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aTag.
					self database add: aTag].
				]
		ifFalse:[self error: 'This tag does not exist'].! !

OCMSTable subclass: #Users
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Users class methodsFor: 'ma operation' stamp: 'has 6/2/2013 19:09'!
add: anUser
	(self loginExists: anUser)
		ifFalse:[OCMSDB commit:[self database add: anUser]]
		ifTrue:[self error: 'This login already exists.'].! !

!Users class methodsFor: 'creation' stamp: 'has 6/2/2013 19:00'!
database
	^ OCMSDB root at: 'users'.! !

!Users class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:29'!
getAll
	"I return a collection with all users in database"
	| reader |
	reader := self database where: [:each | each login from: '' maAlphabeticalNext].
	^ reader.! !

!Users class methodsFor: 'testing' stamp: 'has 6/3/2013 10:22'!
loginExists: anUser
	"I return true if the login already exists."
	| userTemp |
	userTemp := self searchByLogin: anUser login.
	(userTemp isNil)
		ifTrue:[^ false]
		ifFalse:[^ true].! !

!Users class methodsFor: 'ma operation' stamp: 'has 6/2/2013 19:32'!
remove: anUser
	(self database includes: anUser)
		ifTrue:[OCMSDB commit: [self database remove: anUser]]
		ifFalse:[self error: 'This user does not exist'].! !

!Users class methodsFor: 'ma searching' stamp: 'has 6/23/2013 11:02'!
searchByEmail: anEmail
	"return an user with the email typed or nil"
	| reader |
	reader := self database where: [:each | each email = anEmail].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Users class methodsFor: 'ma searching' stamp: 'has 6/2/2013 19:19'!
searchByLogin: aLogin
	"return an user with the login typed or nil"
	| reader |
	reader := self database where: [:each | each login = aLogin].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Users class methodsFor: 'ma searching' stamp: 'has 6/2/2013 19:22'!
searchByName: aName
	"I return a collection with users that contain the typed name"
	| reader |
	reader := self database where: [:each | each name from: aName to: aName maAlphabeticalNext].
	^ reader.! !

!Users class methodsFor: 'ma operation' stamp: 'has 6/2/2013 19:34'!
update: anUser
	(self database includes: anUser)
		ifTrue:[
				OCMSDB commit: [
					self database remove: anUser.
					self database add: anUser].
				]
		ifFalse:[self error: 'This user does not exist'].! !
